> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Update a mapping rule

PATCH https://api.x.flatfile.com/v1/mapping/{programId}/rules/{mappingId}
Content-Type: application/json

Updates a mapping rule in a program

Reference: https://reference.flatfile.com/api-reference/mapping/update-rule

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `programId` (string, required) — ID of the program
- `mappingId` (string, required) — ID of mapping rule

### Body (application/json)

This endpoint expects a MappingRuleConfig.

- `name` (string, required) — Name of the mapping rule
- `type` (string, required)
- `config` (any, optional)
- `acceptedAt` (datetime, optional) — Time the mapping rule was last updated
- `acceptedBy` (string, optional) — User ID of the contributor of the mapping rule
- `metadata` (any, optional) — Metadata of the mapping rule

## Response

### 200

- `data` (MappingRule, required)

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### MappingRule

- `createdAt` (datetime, required) — Time the mapping rule was created
- `id` (string, required) — ID of the mapping rule
- `name` (string, required) — Name of the mapping rule
- `type` (string, required)
- `updatedAt` (datetime, required) — Time the mapping rule was last updated
- `acceptedAt` (datetime, optional) — Time the mapping rule was last updated
- `acceptedBy` (string, optional) — User ID of the contributor of the mapping rule
- `confidence` (integer, optional) — Confidence of the mapping rule
- `config` (any, optional)
- `createdBy` (string, optional) — User ID of the user who suggested the mapping rule
- `deletedAt` (datetime, optional) — Time the mapping rule was deleted
- `metadata` (any, optional) — Metadata of the mapping rule

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Request**

```json
{
  "name": "Assign mapping rule",
  "type": "assign"
}
```

**Response**

```json
{
  "data": {
    "createdAt": "2021-01-01T00:00:00Z",
    "id": "mapping-rule-id",
    "name": "Assign mapping rule",
    "type": "assign",
    "updatedAt": "2021-01-01T00:00:00Z",
    "confidence": 1,
    "config": {},
    "createdBy": "us_usr_YOUR_ID",
    "metadata": {}
  }
}
```

**SDK Code**

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID"

payload = {
    "name": "Assign mapping rule",
    "type": "assign"
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.mapping.updateRule("us_mp_YOUR_ID", "us_mr_YOUR_ID", {
    name: "Assign mapping rule",
    type: "assign",
    config: {},
    metadata: {}
});

```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID"

	payload := strings.NewReader("{\n  \"name\": \"Assign mapping rule\",\n  \"type\": \"assign\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Assign mapping rule\",\n  \"type\": \"assign\"\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Assign mapping rule\",\n  \"type\": \"assign\"\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID', [
  'body' => '{
  "name": "Assign mapping rule",
  "type": "assign"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID");
var request = new RestRequest(Method.PATCH);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Assign mapping rule\",\n  \"type\": \"assign\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Assign mapping rule",
  "type": "assign"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/mapping/us_mp_YOUR_ID/rules/us_mr_YOUR_ID")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```